# 4.4.2

Release date: `2020-04-15`

## Core

- [NXDRIVE-374](https://jira.nuxeo.com/browse/NXDRIVE-374): [GNU/Linux] Use file system decorations
- [NXDRIVE-382](https://jira.nuxeo.com/browse/NXDRIVE-382): Invalid conflict resolution when choosing the local file, if the remote file has been renamed before
- [NXDRIVE-1640](https://jira.nuxeo.com/browse/NXDRIVE-1640): Refactor simple `QMessageBoxes`
- [NXDRIVE-1831](https://jira.nuxeo.com/browse/NXDRIVE-1831): [GNU/Linux] Set the root local folder icon
- [NXDRIVE-1847](https://jira.nuxeo.com/browse/NXDRIVE-1847): [Windows] Fix endless synchronization on fast create-then-rename folder
- [NXDRIVE-1866](https://jira.nuxeo.com/browse/NXDRIVE-1866): Check spurious `ThreadInterrupt` in the conflict resolver
- [NXDRIVE-1869](https://jira.nuxeo.com/browse/NXDRIVE-1869): Handle pair state `resolved-modified` as conflicted
- [NXDRIVE-1893](https://jira.nuxeo.com/browse/NXDRIVE-1893): Remove hardcoded "Nuxeo Drive" strings
- [NXDRIVE-1901](https://jira.nuxeo.com/browse/NXDRIVE-1901): Fix regression introduced in 4.2.0 about invalid `TransferStatus` value
- [NXDRIVE-1918](https://jira.nuxeo.com/browse/NXDRIVE-1918): Use Amazon S3 Direct Upload when available
- [NXDRIVE-1945](https://jira.nuxeo.com/browse/NXDRIVE-1945): Fix mypy issues following the update to `mypy` 0.740
- [NXDRIVE-1958](https://jira.nuxeo.com/browse/NXDRIVE-1958): [Direct Transfer] Create a remote subfolder when uploaing a folder
- [NXDRIVE-1966](https://jira.nuxeo.com/browse/NXDRIVE-1966): Use a custom parent folder for downloads on different partition
- [NXDRIVE-1969](https://jira.nuxeo.com/browse/NXDRIVE-1969): [Windows] Direct Edit should work when the sync folder is not on `C:`
- [NXDRIVE-1970](https://jira.nuxeo.com/browse/NXDRIVE-1970): `get_tree_size()` and `get_tree_list()` should be resilient to OS errors
- [NXDRIVE-1973](https://jira.nuxeo.com/browse/NXDRIVE-1973): Do not sync non-folderish documents without known digest algorithm
- [NXDRIVE-1976](https://jira.nuxeo.com/browse/NXDRIVE-1976): [macOS] Do not fail the auto-update on unmountable volume
- [NXDRIVE-1980](https://jira.nuxeo.com/browse/NXDRIVE-1980): Force apply of local configuration options that use the default value
- [NXDRIVE-1981](https://jira.nuxeo.com/browse/NXDRIVE-1981): Better improvement patch for `safe_filename()`
- [NXDRIVE-1983](https://jira.nuxeo.com/browse/NXDRIVE-1983): [Direct Transfer] Handle username containing non-letter characters
- [NXDRIVE-1984](https://jira.nuxeo.com/browse/NXDRIVE-1984): Handle all errors when checking for opened files
- [NXDRIVE-1985](https://jira.nuxeo.com/browse/NXDRIVE-1985): Fix the custom memory handler buffer retrieval
- [NXDRIVE-1986](https://jira.nuxeo.com/browse/NXDRIVE-1986): [Windows] Ignore FS moves with no source path
- [NXDRIVE-1987](https://jira.nuxeo.com/browse/NXDRIVE-1987): Inexistent database backups should not prevent backup
- [NXDRIVE-2002](https://jira.nuxeo.com/browse/NXDRIVE-2002): Use a stricter `mypy` configuration
- [NXDRIVE-2005](https://jira.nuxeo.com/browse/NXDRIVE-2005): Use stricter `flake8` plugins in pre-commit
- [NXDRIVE-2008](https://jira.nuxeo.com/browse/NXDRIVE-2008): Run codespell on the entire code base
- [NXDRIVE-2010](https://jira.nuxeo.com/browse/NXDRIVE-2010): Restart the download on HTTP 416 error (range not satisfiable)
- [NXDRIVE-2012](https://jira.nuxeo.com/browse/NXDRIVE-2012): Upgrade to `sentry-sdk` 0.14.1 to fix memory leaks
- [NXDRIVE-2022](https://jira.nuxeo.com/browse/NXDRIVE-2022): Allow text selection into the errors/conflicts window
- [NXDRIVE-2023](https://jira.nuxeo.com/browse/NXDRIVE-2023): Make the error title an URL to the remote document
- [NXDRIVE-2027](https://jira.nuxeo.com/browse/NXDRIVE-2027): Allow Direct Edit on custom blob metadata values
- [NXDRIVE-2040](https://jira.nuxeo.com/browse/NXDRIVE-2040): [Direct Transfer] Temporary disable folder uploads
- [NXDRIVE-2047](https://jira.nuxeo.com/browse/NXDRIVE-2047): Unlock updates on the `centralized` channel when auto-update is disabled
- [NXDRIVE-2048](https://jira.nuxeo.com/browse/NXDRIVE-2048): Reduce the amount of process information retrieved in the Auto-Locker
- [NXDRIVE-2049](https://jira.nuxeo.com/browse/NXDRIVE-2049): Skip malformed local configuration files
- [NXDRIVE-2052](https://jira.nuxeo.com/browse/NXDRIVE-2052): Optimize CPU consumption (and laptop batteries)
- [NXDRIVE-2054](https://jira.nuxeo.com/browse/NXDRIVE-2054): Ask for a new batch in case of failed S3 upload resuming
- [NXDRIVE-2055](https://jira.nuxeo.com/browse/NXDRIVE-2055): Process queued Qt events on `CTRL`+`C`
- [NXDRIVE-2075](https://jira.nuxeo.com/browse/NXDRIVE-2075): [Windows] Use the long path prefix for `Engine.download_dir`
- [NXDRIVE-2079](https://jira.nuxeo.com/browse/NXDRIVE-2079): Auto-enabling behaviors/features behind flags
- [NXDRIVE-2082](https://jira.nuxeo.com/browse/NXDRIVE-2082): [Direct Transfer] Disable the feature until it is stable enough
- [NXDRIVE-2086](https://jira.nuxeo.com/browse/NXDRIVE-2086): Fix mypy issues following the update to `mypy` 0.770
- [NXDRIVE-2088](https://jira.nuxeo.com/browse/NXDRIVE-2088): Make the synchronization_enabled option effective locally in certain conditions
- [NXDRIVE-2090](https://jira.nuxeo.com/browse/NXDRIVE-2090): Ask for application restart on specific server config change
- [NXDRIVE-2091](https://jira.nuxeo.com/browse/NXDRIVE-2091): Wait for the server configuration before starting features
- [NXDRIVE-2092](https://jira.nuxeo.com/browse/NXDRIVE-2092): Fix `Downloads.path` and `Uploads.path` database field type
- [NXDRIVE-2100](https://jira.nuxeo.com/browse/NXDRIVE-2100): Clean-up code smells found by Sourcery
- [NXDRIVE-2103](https://jira.nuxeo.com/browse/NXDRIVE-2103): [S3] Disable the feature until it is fully usable
- [NXDRIVE-2115](https://jira.nuxeo.com/browse/NXDRIVE-2115): Fix `flake8` issues following the update to `pyflakes` 2.2.0
- [NXDRIVE-2118](https://jira.nuxeo.com/browse/NXDRIVE-2118): Make the `delay` option effective when set from the server config

## GUI

- [NXDRIVE-1255](https://jira.nuxeo.com/browse/NXDRIVE-1255): Add tooltips to icons in systray menu
- [NXDRIVE-1899](https://jira.nuxeo.com/browse/NXDRIVE-1899): Make the account selection more obvious
- [NXDRIVE-1900](https://jira.nuxeo.com/browse/NXDRIVE-1900): Fix display scaling when zoom is set to > 100%
- [NXDRIVE-1968](https://jira.nuxeo.com/browse/NXDRIVE-1968): Raise the Settings window on account addition error
- [NXDRIVE-1990](https://jira.nuxeo.com/browse/NXDRIVE-1990): [Direct Transfer] Disable the OK button when no local path selected
- [NXDRIVE-2021](https://jira.nuxeo.com/browse/NXDRIVE-2021): Use a more appropriate "open remote URL" icon
- [NXDRIVE-2042](https://jira.nuxeo.com/browse/NXDRIVE-2042): Display the disk free space at different places
- [NXDRIVE-2074](https://jira.nuxeo.com/browse/NXDRIVE-2074): Always raise the Conflicts/Errors window
- [NXDRIVE-2081](https://jira.nuxeo.com/browse/NXDRIVE-2081): Several small UX improvements

## Packaging / Build

- [NXDRIVE-1971](https://jira.nuxeo.com/browse/NXDRIVE-1971): [Windows] Fix a `TypeError` when no enough rights on the local sync folder (by upgrading `watchdog` as the fix was sent upstream)
- [NXDRIVE-1992](https://jira.nuxeo.com/browse/NXDRIVE-1992): Fix old alpha files purgation
- [NXDRIVE-1993](https://jira.nuxeo.com/browse/NXDRIVE-1993): Use `Dependabot` to keep dependencies up-to-date
- [NXDRIVE-2001](https://jira.nuxeo.com/browse/NXDRIVE-2001): Pin the `pip` version to ease reproductible builds
- [NXDRIVE-2050](https://jira.nuxeo.com/browse/NXDRIVE-2050): Provide auto-update scripts for wide deployment
- [NXDRIVE-2056](https://jira.nuxeo.com/browse/NXDRIVE-2056): [GNU/Linux] `PyInstaller` 3.6 broke AppImage builds
- [NXDRIVE-2062](https://jira.nuxeo.com/browse/NXDRIVE-2062): Upgrade mac-drive-2 to 10.13.6 (High Sierra)
- [NXDRIVE-2068](https://jira.nuxeo.com/browse/NXDRIVE-2068): Upgrade mac-drive-1 to 10.13.6 (High Sierra)
- [NXDRIVE-2064](https://jira.nuxeo.com/browse/NXDRIVE-2064): Use GitHub Actions to run quality and unit tests
- [NXDRIVE-2104](https://jira.nuxeo.com/browse/NXDRIVE-2104): [GNU/Linux] Fix the docker image name to use for packaging

## Tests

- [NXDRIVE-1991](https://jira.nuxeo.com/browse/NXDRIVE-1991): Fix the tests "rerun" mechanism
- [NXDRIVE-1994](https://jira.nuxeo.com/browse/NXDRIVE-1994): [Windows] Skip `JUnit` report when running a specific test
- [NXDRIVE-1996](https://jira.nuxeo.com/browse/NXDRIVE-1996): Add a script to check translations files
- [NXDRIVE-2003](https://jira.nuxeo.com/browse/NXDRIVE-2003): Skip inexistent group deletion in `test_group_changes.py`
- [NXDRIVE-2004](https://jira.nuxeo.com/browse/NXDRIVE-2004): Allow to customize document types in tests
- [NXDRIVE-2013](https://jira.nuxeo.com/browse/NXDRIVE-2013): Create a script to convert NCO CSV log files to real log files
- [NXDRIVE-2063](https://jira.nuxeo.com/browse/NXDRIVE-2063): Move tests logic to tox
- [NXDRIVE-2067](https://jira.nuxeo.com/browse/NXDRIVE-2067): Remove the nuxeo-dam dependency in tests
- [NXDRIVE-2069](https://jira.nuxeo.com/browse/NXDRIVE-2069): Don't use dots in custom HTTP headers in tests
- [NXDRIVE-2080](https://jira.nuxeo.com/browse/NXDRIVE-2080): Fix SonarCube coverage report path
- [NXDRIVE-2096](https://jira.nuxeo.com/browse/NXDRIVE-2096): Make the `JUnit` merge script universal
- [NXDRIVE-2105](https://jira.nuxeo.com/browse/NXDRIVE-2105): Fix a random bug in `test_move_parent_while_syncing_a_lot_of_files()`
- [NXDRIVE-2106](https://jira.nuxeo.com/browse/NXDRIVE-2106): Bypass the `rm_rf` pytest warning on Windows
- [NXDRIVE-2109](https://jira.nuxeo.com/browse/NXDRIVE-2109): Properly skip OS based tests when run from another OS

## Docs

- [NXDRIVE-2078](https://jira.nuxeo.com/browse/NXDRIVE-2078): Write the features DEP

## Minor Changes

- Added `boto3` 1.12.19
- Added `botocore` 1.15.19
- Added `docutils` 0.15.2
- Added `jmespath` 0.9.5
- Added `s3transfer` 0.3.2
- Upgraded `altgraph` from 0.16.1 to 0.17
- Upgraded `certify` from 2019.9.11 to 2019.11.28
- Upgraded `cffi` from 1.12.3 to 1.14.0
- Upgraded `distro` from 1.4.0 to 1.5.0
- Upgraded `future` 0.18.0 to 0.18.2
- Upgraded `idna` 2.8 to 2.9
- Upgraded `macholib` from 1.11 to 1.14
- Upgraded `markdown` from 3.1.1 to 3.2.1
- Upgraded `nuxeo` 2.3.0 to commit-764c064
- Upgraded `pip` from 19.3.1 to 20.0.2
- Upgraded `psutil` from 5.6.3 to 5.7.0
- Upgraded `pycparser` from 2.19 to 2.20
- Upgraded `pycriptodomex` from 3.9.0 to 3.9.7
- Upgraded `pyinstaller` from commit-3f57c91 to commit-41237b1
- Upgraded `pyobjc-core` from 5.2 to 6.1
- Upgraded `pyobjc-framework-Cocoa` from 5.2 to 6.1
- Upgraded `pyobjc-framework-CoreServices` from 5.2 to 6.1
- Upgraded `pyobjc-framework-FSEvents` from 5.2 to 6.1
- Upgraded `pyobjc-framework-ScriptingBridge` from 5.2 to 6.1
- Upgraded `pyobjc-framework-SystemConfiguration` from 5.2 to 6.1
- Upgraded `pyqt5` from 5.13.1 to 5.13.2
- Upgraded `python-dateutil` from 2.8.0 to 2.8.1
- Upgraded `pywin32` from 225 to 227
- Upgraded `pyyaml` from 5.1.2 to 5.3.1
- Upgraded `requests` from 2.22.0 to 2.23.0
- Upgraded `sentry-sdk` from 0.12.3 to 0.14.3
- Upgraded `six` from 1.12.0 to 1.14.0
- Upgraded `tld` from 0.9.6 to 0.11.9
- Upgraded `urllib3` from 1.25.6 to 1.25.8
- Upgraded `watchdog` from commit-6793588 to 0.10.2
- Upgraded `xattr` from 0.9.6 to 0.9.7
- Testing: The `SENTRY_ENV` envar is now automatically retrieved based on the branch name

## Technical Changes

- Added `Application.point_size`
- Added `Application.display_warning()`
- Added `Application.show_msgbox_restart_needed()`
- Removed `Application.ratio`
- Removed `BlacklistItem.uid`
- Removed `BlacklistItem.name` (`str`). Use `path` (`pathlib.Path`) instead.
- Removed `uid` argument from `BlacklistQueue.push()`
- Changed `name` argument of `BlacklistQueue.push()` from `str` to `pathlib.Path`
- Added `CustomMemoryHandler.flush()`
- Changed `Download.tmpname` from `Optional[str]` to `Optional[Path]`
- Added `EngineDAO.update_upload()`
- Removed `Engine.account`
- Added `Manager.restartNeeded` signal
- Changed `Manager.is_paused()` from a function to an attribute
- Removed `Manager.refresh_update_status()`. Use `.updater.refresh_status()` instead.
- Changed `dao` argument of `ProcessAutoLockerWorker.__init__()` to `manager`
- Added `QMLDriveApi.open_document`
- Added `Remote.personal_space()`
- Removed `RemoteWatcher.server_interval`
- Removed `delay` argument of `RemoteWatcher.__init__()`. Use `Options.delay` instead.
- Changed `Upload.batch` from `str` to `nuxeo.models.Batch`
- Removed `Upload.idx`. Use `Upload.batch["upload_idx"]` instead.
- Removed `idx` column from `Uploads` table
- Added `behavior.py`
- Removed constants.py::`FORBID_CHARS_ALL`
- Removed constants.py::`FORBID_CHARS_UNIX`
- Added `features.py`
- Added updater/constants.py::`AutoUpdateState`
- Added updater/utils.py::`auto_updates_state()`
- Removed utils.py::`safe_os_filename()`. Use `safe_filename()` instead.
